   10 REM UTCAP.BAS
   20 REM OSCAR-11 Capture Program for Windows 98 to XP
   30 REM Time stamp listed as Local
   40 REM Based on UCAP, with automatic time stamp at regular intervals
   50 
   60 REM Requires hardward demodulator on COM1 port
   70 REM Written by Clive Wallis G3CWV
   80 REM Created 01 February 2005
   90 REM Version 0.1  14 January 2006
  100 REM Version 0.2 Time stamp changed to Local
  110 REM Intrepreter BBC BASIC for Windows
  120 REM ---------------------------
  130 
  140 time_int = 10 :REM Auto time interval in minutes.
  150 time_int = time_int * 60 * 100
  160 
  170 PRINT
  180 PRINT "F4 to toggle CAPTURE, F10 for TIME STAMP, X to EXIT"
  190 maxlen = 70 :REM Max line length for display
  200 f1 = OPENOUT("temp.dat")
  210 capture=TRUE
  220 exit = FALSE
  230 PRINT
  240 PRINT "Capture is ON"
  250 port% = OPENUP "COM1: baud=1200 parity=N data=8 stop=1"
  260 IF port% = 0 PRINT "Could not open COM1" : END
  270 REPEAT
  280   chars% = EXT#port%  :REM Check port for character
  290   IF chars% <> 0 THEN
  300     FOR count% = 1 TO chars%
  310       data% = BGET#port%
  320       PROCfilter
  330       IF (capture)AND(outch$<>"") THEN BPUT#f1,data%
  340       PROCdisplay
  350     NEXT
  360   ENDIF
  370   REM Check keyboard
  380   
  390   key = INKEY(0) :REM Key F4 is 148, F10 is 154, X is 120
  400   CASE key OF
  410     WHEN 148: capture = NOT capture:
  420       IF capture THEN PRINT "Capture is ON" ELSE PRINT "Capture is OFF"
  430       
  440     WHEN 154  PROCshow_time
  450       
  460     WHEN 120 : exit = TRUE
  470       
  480   ENDCASE
  490   
  500   IF TIME > time_int THEN
  510     PROCshow_time
  520     TIME = 0
  530   ENDIF
  540   
  550 UNTIL exit
  560 CLOSE#0
  570 PRINT:
  580 PRINT
  590 PRINT "PROGRAM TERMINATED"
  600 PRINT
  610 PRINT"Please rename output file"
  620 END
  630 REM --------
  640 
  650 DEF PROCfilter
  660 
  670 REM Removes non printable ASCII codes
  680 REM Input data%
  690 REM Output outch$
  700 
  710 data% = data% AND 127
  720 IF ((data% >31)AND(data%< 127)) OR (data% = 10) OR (data% = 13) THEN
  730   outch$ = CHR$(data%)
  740 ELSE outch$ = ""
  750 ENDIF
  760 ENDPROC
  770 REM ------
  780 
  790 DEF PROCdisplay
  800 
  810 REM Outputs to screen & makes sure lines do not overflow
  820 
  830 REM Input outch$, linelen, maxlen
  840 
  850 REM Output linelen
  860 
  870 
  880 linelen = linelen+1
  890 IF linelen>maxlen THEN
  900   PRINT
  910   linelen=0
  920 ENDIF
  930 PRINT outch$;
  940 
  950 ENDPROC
  960 
  970 REM --------------
  980 
  990 DEF PROCshow_time
 1000 
 1010 time$ = TIME$ :
 1020 time$ = CHR$(13)+CHR$(10)+time$+" Local" + CHR$(13)+CHR$(10):
 1030 FOR I = 1 TO LEN(time$) :
 1040   outch$ = MID$(time$,I,1)  :
 1050   BPUT#f1,ASC(outch$)  :
 1060   PROCdisplay
 1070 NEXT I
 1080 
 1090 ENDPROC
