   10 REM. Time Diff
   20 REM Program to calculate time difference between to times in Days, hours, minutes & seconds
   30 REM Written by Clive Wallis   G3CWV
   40 REM Created 24 February 2006
   50 REM Version 0.1
   60 REM Code for creating boxes is based on Richard Russel's SOLVE.BBC
   70 REM
   80 IF HIMEM<PAGE+9999 THEN HIMEM=PAGE+3500
   90 INSTALL @lib$+"arraylib"
  100 INSTALL @lib$+"winlib5"
  110 INSTALL @lib$+"FNUSING"
  120 
  130 
  140 
  150 U% = 8 :REM Define nunmber of text boxes
  160 VDU 23,22,720;368;8,16,16,128:OFF
  170 DIM M(U%-1,U%-1),V(U%-1,0),H%(U%-1,U%),T% 10  :REM define data arrays
  180 
  190 FOR R% = 0 TO 2                         :REM Rows
  200   
  210   FOR C% = 0 TO 4                       :REM Columns
  220     
  230     CASE (R%*10+1)* (C%+1) OF
  240         REM Label text boxes
  250       WHEN 1  text$ =""
  260         
  270       WHEN 2 text$ = "DAY"
  280         
  290       WHEN 3 text$ = " HR"
  300       WHEN 4 text$ = "MIN"
  310       WHEN 5 text$ = "SEC"
  320       WHEN 11 text$="UTC"
  330       WHEN 21 text$= "SAT"
  340       OTHERWISE text$ = ""
  350     ENDCASE
  360     IF NOT((R% = 0) AND (C% = 0 )) THEN
  370       REM Miss box in top LH corner
  380       H%(R%,C%) = FN_editbox(text$,C%*100+50,R%*100+20,42,20,0,&810080)  :REM Puts 0 in boxes
  390     ENDIF
  400   NEXT
  410 NEXT
  420 
  430 S% = FN_button("CALCULATE",328,270,150,30,100,0)      :REM Defines button
  440 
  450 ON SYS IF @wparam%=100 PROCsolve:RETURN ELSE RETURN  :REM =100 refers to 100 above
  460 
  470 PRINT TAB(24,19)"Enter values in boxes then click on CALCULATE"''
  480 REPEAT UNTIL INKEY(1)=0  :REM Hold program until box clicked
  490 
  500 DEF PROCsolve
  510 REM Procedure to get data from text boxes, and calculate time difference
  520 PRINT TAB(0,21) SPC170 TAB(0,21);
  530 
  540 SYS "GetWindowText",H%(1,1),T%,10 TO L% : T%?L% = 13
  550 
  560 utc_dy = VAL$ T%
  570 SYS "GetWindowText",H%(1,2),T%,10 TO L% : T%?L% = 13
  580 utc_hr = VAL$ T%
  590 SYS "GetWindowText",H%(1,3),T%,10 TO L% : T%?L% = 13
  600 utc_min = VAL$ T%
  610 SYS "GetWindowText",H%(1,4),T%,10 TO L% : T%?L% = 13
  620 utc_sec = VAL$ T%
  630 SYS "GetWindowText",H%(2,1),T%,10 TO L% : T%?L% = 13
  640 sat_dy = VAL$ T%
  650 
  660 SYS "GetWindowText",H%(2,2),T%,10 TO L% : T%?L% = 13
  670 sat_hr = VAL$ T%
  680 
  690 SYS "GetWindowText",H%(2,3),T%,10 TO L% : T%?L% = 13
  700 sat_min = VAL$ T%
  710 
  720 SYS "GetWindowText",H%(2,4),T%,10 TO L% : T%?L% = 13
  730 sat_sec = VAL$ T%
  740 
  750 error = sat_dy+sat_hr/24+sat_min/24/60+sat_sec/24/3600 - (utc_dy+utc_hr/24+utc_min/24/60+utc_sec/24/3600)
  760 
  770 PRINT TAB(24,21);FNusing("Time Error = ###.#####  Days",error)
  780 
  790 ENDPROC
