   10 REM UCAP.BBC
   20 REM OSCAR-11 Capture Program for Windows 98 to XP
   30 REM Time stamp listed as UTC
   40 REM Requires hardward demodulator on COM1 port
   50 REM Written by Clive Wallis G3CWV
   60 REM Created 16 August 2005
   70 REM Version 1.0  14 January 2006
   80 REM Intrepreter BBC BASIC for Windows
   90 REM ---------------------------
  100 PRINT
  110 PRINT "F4 to toggle CAPTURE, F10 for TIME STAMP, X to EXIT"
  120 maxlen = 70 :REM Max line length for display
  130 f1 = OPENOUT("temp.dat")
  140 capture=TRUE
  150 exit = FALSE
  160 PRINT
  170 PRINT "Capture is ON"
  180 port% = OPENUP "COM1: baud=1200 parity=N data=8 stop=1"
  190 IF port% = 0 PRINT "Could not open COM1" : END
  200 REPEAT
  210   chars% = EXT#port%  :REM Check port for character
  220   IF chars% <> 0 THEN
  230     FOR count% = 1 TO chars%
  240       data% = BGET#port%
  250       PROCfilter
  260       IF (capture)AND(outch$<>"") THEN BPUT#f1,data%
  270       PROCdisplay
  280     NEXT
  290   ENDIF
  300   REM Check keyboard
  310   
  320   key = INKEY(0) :REM Key F4 is 148, F10 is 154, X is 120
  330   CASE key OF
  340     WHEN 148: capture = NOT capture:
  350       IF capture THEN PRINT "Capture is ON" ELSE PRINT "Capture is OFF"
  360       
  370     WHEN 154: time$ = TIME$ :
  380       time$ = CHR$(13)+CHR$(10)+time$+" UTC"+CHR$(13)+CHR$(10):
  390       FOR I = 1 TO LEN(time$) :
  400         outch$ = MID$(time$,I,1)  :
  410         BPUT#f1,ASC(outch$)  :
  420         PROCdisplay
  430       NEXT I
  440     WHEN 120 : exit = TRUE
  450       
  460   ENDCASE
  470   
  480 UNTIL exit
  490 CLOSE#0
  500 PRINT:
  510 PRINT
  520 PRINT "PROGRAM TERMINATED"
  530 PRINT
  540 PRINT"Please rename output file"
  550 END
  560 REM --------
  570 
  580 DEF PROCfilter
  590 
  600 REM Removes non printable ASCII codes
  610 REM Input data%
  620 REM Output outch$
  630 
  640 data% = data% AND 127
  650 IF ((data% >31)AND(data%< 127)) OR (data% = 10) OR (data% = 13) THEN
  660   outch$ = CHR$(data%)
  670 ELSE outch$ = ""
  680 ENDIF
  690 ENDPROC
  700 REM ------
  710 
  720 DEF PROCdisplay
  730 
  740 REM Outputs to screen & makes sure lines do not overflow
  750 
  760 REM Input outch$, linelen, maxlen
  770 
  780 REM Output linelen
  790 
  800 
  810 linelen = linelen+1
  820 IF linelen>maxlen THEN
  830   PRINT
  840   linelen=0
  850 ENDIF
  860 PRINT outch$;
  870 
  880 ENDPROC
